c***********************************************************************
c     Programa mcnf852pprn per transformar dades mcnf85 a dades per 
c     poder ser tractades directament pel programa pprn
c***********************************************************************
c     main
      implicit none
      integer*4 MAXW
      parameter (MAXW= 5000000)      
      real*4 w(MAXW)
c     dades de la xarxa
      integer*4 nnu,nar,nat
      integer*4 pcost,pcap,pcmt,picmt,pinj,pmnk,pmnl
      integer*4 ncost,ncap,ncmt,nicmt,ninj,nmnk,nmnl
c     variables locals
      character*80 strin,strout

c     llegim quin es el fitxer 1 d'entrada
      write(*,*) 'Fitxer d''entrada (extensio per defecte es .mcn)?'
      read(*,*) strin
      if (index(strin,'.').eq.0) then 
         call concat(strin,strin,'.mcn')
      endif

c     obrim fitxer 1 d'entrada i llegim dades .mcn
      open(unit=1,err=900,file=strin,status='old')       
      call llegir_dimensio_problema(1,nnu,nar,nat)
c     alocatem memoria
      pcost=1 
      ncost= 2*nar*nat

      pcap= pcost+ncost
      ncap= 2*nar*nat

      pcmt= pcap+ncap
      ncap= 2*nar

      picmt= pcmt+ncap
      nicmt= 2*nar

      pmnk= picmt+nicmt
      nmnk= nar

      pmnl= pmnk+nmnk
      nmnl= nar

      pinj= pmnl+nmnl
      ninj= 2*nnu*nat

c     netegem dades alocatades
      call netejar_dades(nar,nat,nnu,w(pcost),w(pcap),w(pcmt),w(picmt),
     +     w(pmnk),w(pmnl),w(pinj))

c     llegim resta de dades del problema
      call llegir_icmt(1,nar,w(picmt))
      call llegir_dades_mcnf(1,nar,nat,nnu,w(pcost),w(pcap),w(pcmt),
     +     w(picmt),w(pmnk),w(pmnl),w(pinj))
      close(1)

c     obrim fitxer de sortida de resultats 1, i creem .dat
      strout= strin(1:index(strin,'.'))
      call concat(strout,strout,'dat')
      open(unit=2,file=strout,status='unknown')
      call write_pprn(2,nar,nat,nnu,w(pcost),w(pcap),w(pcmt),w(pmnk),
     +     w(pmnl),w(pinj))
      close(2)

      stop
 900  stop 'No es pot obrir fitxer d entrada'
      end                       !fi programa principal


c***********************************************************************
c     rutina per fer la lectura de dimensio del problema
c***********************************************************************
      subroutine llegir_dimensio_problema(in,nnu,nar,nat)
      implicit none
c     parametres 
      integer*4 in,nnu,nar,nat

      read(in,*) nnu,nat,nar
      end !fi subrutina


c***********************************************************************
c     rutina per netejar dades
c***********************************************************************
      subroutine netejar_dades(nar,nat,nnu,cost,cap,cmt,icmt,mnk,
     +     mnl,inj)
      implicit none
c     parametres 
      integer*4 nar,nat,nnu
      real*8 cost(nar,nat),cap(nar,nat),cmt(nar),icmt(nar),inj(nnu,nat)
      integer*4 mnk(nar),mnl(nar)

c     variables locals
      integer*4 i,k
      
      do k= 1,nat
         do i= 1,nar
            cost(i,k)= 0.0d0
            cap(i,k)= 0.0d0
         end do
         do i=1,nnu
            inj(i,k)= 0.0d0
         end do
      end do
      do i= 1,nar
         mnk(i)= 0
         mnl(i)= 0
         cmt(i)= 0.0d0
         icmt(i)= 0.0d0
      end do
      end


c***********************************************************************
c     rutina per fer la lectura de icmt
c***********************************************************************
      subroutine llegir_icmt(in,nar,icmt)
      implicit none
c     parametres 
      integer*4 in,nar
      real*8 icmt(nar)
c     variables locals
      integer*4 i,j,k,l,m
      real*8 f,f1,f2

c     saltem linies
 10   read(in,*) i,j,f1
      if (j.ne.0) goto 10
 20   read(in,*) m,i,j,k,f1,f2,l
      if (i.ne.0) goto 20
c     llegim icmt
 30   read(in,*) i,f
      if (i.ne.0) then
         icmt(i)= f
         goto 30
      end if
      end 



c***********************************************************************
c     rutina per fer la lectura de dades de fitxer d'entrada
c     eliminant capacitats individuals a 0 (posem una capacitat
c     petita 1e-6)
c***********************************************************************
      subroutine llegir_dades_mcnf(in,nar,nat,nnu,cost,cap,cmt,icmt,mnk,
     +     mnl,inj)
      implicit none
c     parametres 
      integer*4 in,nar,nat,nnu
      real*8 cost(nar,nat),cap(nar,nat),cmt(nar),icmt(nar),inj(nnu,nat)
      integer*4 mnk(nar),mnl(nar)
c     funcions
c      logical existeix_arc
c     variables locals
      character*6 str
      integer*4 arc,i,j,k,kabans,l,ct,iarc,na,igk
      real*8 f1,f2

      rewind(in)
      read(in,*)
c
 10   read(in,*) i,j,f1
      if (j.ne.0) then
         inj(i,j)= f1
         goto 10
      end if
c    
      ct= 0
      kabans= 0
 20   read(in,*) arc,i,j,k,f1,f2,l
      if (j.ne.0) then
         mnk(arc)= i
         mnl(arc)= j
         if (l.eq.0) then 
            cmt(arc)= 1.0D+32
         else
            cmt(arc)= icmt(l) 
         end if
         cost(arc,k)= f1
         if (f2.lt.0.) then
            cap(arc,k)= 1.0D+32
         else
            cap(arc,k)= f2
         end if            
         goto 20
      end if
c      do k= 1,nat
c         do i=1,nar
c            if (cap(i,k).eq.0.0d0) cap(i,k)= 1.0e-6
c         end do
c      end do
      end !fi subrutina


c***********************************************************************
c     rutina per comprovar si existeix o no un arc
c***********************************************************************
      logical function existeix_arc(nar,mnk,mnl,k,l,n)
      implicit none
c     parametres 
      integer*4 nar,mnk(nar),mnl(nar),k,l,n
c     variables locals
      integer*4 i

      existeix_arc= .false.
      do i= 1,n
         if ( (mnk(i).eq.k).and.(mnl(i).eq.l) ) then
            existeix_arc= .true.
            return
         end if
      end do
      end


c***********************************************************************
c     rutina per generar dades pprn
c***********************************************************************
      subroutine write_pprn(out,nar,nat,nnu,cost,cap,cmt,mnk,
     +     mnl,inj)
      implicit none
c     parametres 
      integer*4 nar,nat,nnu
      real*8 cost(nar,nat),cap(nar,nat),cmt(nar),inj(nnu,nat)
      integer*4 mnk(nar),mnl(nar)
      integer*4 out
c     variables locals
      integer*4 i,k,ncb

      ncb= 0
c     escrivim a fitxer de sortida
      write(out,*) nnu,nar,nat,ncb,0
      write(out,*) 'COSTOS PER ARTICLE'
      do k= 1,nat
         write(out,*) (cost(i,k),i=1,nar)
      end do
      write(out,*) 'CAPACITATS PER ARTICLE'
      do k= 1,nat
         write(out,*) (cap(i,k),i=1,nar)
      end do
      write(out,*) 'INJECCIONS PER ARTICLE'
      do k= 1,nat
         write(out,*) (inj(i,k),i=1,nnu)
      end do
      write(out,*) 'CAPACITAT MUTUA'
      write(out,*) (cmt(i),i=1,nar)
      write(out,*) 'TOPOLOGIA XARXA'
      do i= 1,nar
         write (out,*) mnk(i),mnl(i)
      end do
      end  !fi subrutina      

c***********************************************************************
c     rutina per concatenar els strings str2 i str3 i deixar-ho en str1
c     es suposa que l'string finalitza amb el primer ' ' (si no existeix
c     l'string es tota la variable) a partir
c     d'on es concatena. str1 pot ser str2 o str3 sense cap problema.
c***********************************************************************
      subroutine concat(str1,str2,str3)
      character*(*) str1,str2,str3
      integer*4 n
      
      n= index(str2,' ')
      if (n.eq.0) then
         str1= str2//str3
      else
         str1= str2(1:n-1)//str3
      end if
      end
      
      
c***********************************************************************
c     rutina per transformar un enter positiu en string
c     n es l'enter;s es l'string;l el total de caracters a escriure a s
c***********************************************************************
      subroutine itostr(n,s,l)
      integer*4 n,l
      character*(*) s
      
      integer*4 i,digit,zero,auxn
      
      s=' '
      auxn= n
      zero= ichar('0')
      do i=1,l
         digit= mod(auxn,10)
         auxn= auxn/10
         s(l-i+1:l-i+1)= char(digit+zero)	
      end do
      end
      
      
